#include <windows.h>
#include <stdio.h>
#include "ps3000.h"

short _ready;
short **_buffers;
short _overflow;
unsigned long _triggeredAt;
short _triggered;
short _auto_stop;
unsigned long _nValues;

void __stdcall GetValuesCallback(short **overviewBuffers, short overflow, unsigned long triggeredAt, short triggered,
  short auto_stop,unsigned long nValues)
{
	_buffers = overviewBuffers;
	_overflow = overflow;
	_triggeredAt = triggeredAt;
	_triggered = triggered;
	_auto_stop = auto_stop;
	_nValues = nValues;
	_ready = 1;
}

extern short __declspec(dllexport) __stdcall PollFastStreaming(short handle)
{
	_ready = 0;
	return ps3000_get_streaming_last_values(handle, (void *)GetValuesCallback);
}

extern short __declspec(dllexport) __stdcall FastStreamingReady(short handle)
{
	return _ready;
}

extern short __declspec(dllexport) __stdcall GetFastStreamingDetails(short handle, short * overflow, unsigned long * triggeredAt, 
		short * triggered, short * auto_stop)
{
	if(_ready)
	{
		*overflow = _overflow;
		*triggeredAt = _triggeredAt;
		*triggered = _triggered;
		*auto_stop = _auto_stop;	
		return _nValues;
	}
	return 0;
}

extern unsigned long __declspec(dllexport) __stdcall GetFastStreamingValuesAggregated(short handle, short channel, short * bufferMax, short * bufferMin)
{
	if(_ready)
	{
		short index = channel * 2;
		if(bufferMax != NULL && _buffers[index] != NULL) memcpy(bufferMax, _buffers[index], _nValues * sizeof(short));
		if(bufferMin != NULL && _buffers[index + 1] != NULL) memcpy(bufferMin, _buffers[index + 1], _nValues * sizeof(short));

		return _nValues;
	}

	return 0;
}

extern unsigned long __declspec(dllexport) __stdcall GetFastStreamingValues(short handle, short channel, short * buffer)
{
	if(_ready)
	{
		if(buffer != NULL && _buffers[channel] != NULL) memcpy(buffer, _buffers[channel], _nValues * sizeof(short));
		return _nValues;
	}

	return 0;
}